// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-svd.py from FE310.svd, see https://github.com/AdaCore/svd2ada/tree/master/CMSIS-SVD/SiFive-Community

// E31 CPU Coreplex, high-performance, 32-bit RV32IMAC core
//


.syntax unified

// This is the default handler for interrupts, if triggered but not defined.
.section .text.Default_Handler
.global  Default_Handler
.type    Default_Handler, %function
Default_Handler:
    wfe
    b    Default_Handler

// Avoid the need for repeated .weak and .set instructions.
.macro IRQ handler
    .weak  \handler
    .set   \handler, Default_Handler
.endm

// Must set the "a" flag on the section:
// https://svnweb.freebsd.org/base/stable/11/sys/arm/arm/locore-v4.S?r1=321049&r2=321048&pathrev=321049
// https://sourceware.org/binutils/docs/as/Section.html#ELF-Version
.section .isr_vector, "a", %progbits
.global  __isr_vector
    // Interrupt vector as defined by Cortex-M, starting with the stack top.
    // On reset, SP is initialized with *0x0 and PC is loaded with *0x4, loading
    // _stack_top and Reset_Handler.
    .long _stack_top
    .long Reset_Handler
    .long NMI_Handler
    .long HardFault_Handler
    .long MemoryManagement_Handler
    .long BusFault_Handler
    .long UsageFault_Handler
    .long 0
    .long 0
    .long 0
    .long 0
    .long SVC_Handler
    .long DebugMon_Handler
    .long 0
    .long PendSV_Handler
    .long SysTick_Handler

    // Extra interrupts for peripherals defined by the hardware vendor.
    .long 0
    .long Watchdog_IRQ_IRQHandler
    .long RTC_IRQ_IRQHandler
    .long UART0_IRQ_IRQHandler
    .long UART1_IRQ_IRQHandler
    .long QSPI0_IRQ_IRQHandler
    .long QSPI1_IRQ_IRQHandler
    .long QSPI2_IRQ_IRQHandler
    .long GPIO_0_IRQ_IRQHandler
    .long GPIO_1_IRQ_IRQHandler
    .long GPIO_2_IRQ_IRQHandler
    .long GPIO_3_IRQ_IRQHandler
    .long GPIO_4_IRQ_IRQHandler
    .long GPIO_5_IRQ_IRQHandler
    .long GPIO_6_IRQ_IRQHandler
    .long GPIO_7_IRQ_IRQHandler
    .long GPIO_8_IRQ_IRQHandler
    .long GPIO_9_IRQ_IRQHandler
    .long GPIO_10_IRQ_IRQHandler
    .long GPIO_11_IRQ_IRQHandler
    .long GPIO_12_IRQ_IRQHandler
    .long GPIO_13_IRQ_IRQHandler
    .long GPIO_14_IRQ_IRQHandler
    .long GPIO_15_IRQ_IRQHandler
    .long GPIO_16_IRQ_IRQHandler
    .long GPIO_17_IRQ_IRQHandler
    .long GPIO_18_IRQ_IRQHandler
    .long GPIO_19_IRQ_IRQHandler
    .long GPIO_20_IRQ_IRQHandler
    .long GPIO_21_IRQ_IRQHandler
    .long GPIO_22_IRQ_IRQHandler
    .long GPIO_23_IRQ_IRQHandler
    .long GPIO_24_IRQ_IRQHandler
    .long GPIO_25_IRQ_IRQHandler
    .long GPIO_26_IRQ_IRQHandler
    .long GPIO_27_IRQ_IRQHandler
    .long GPIO_28_IRQ_IRQHandler
    .long GPIO_29_IRQ_IRQHandler
    .long GPIO_30_IRQ_IRQHandler
    .long GPIO_31_IRQ_IRQHandler
    .long PWMO_CMP0_IRQ_IRQHandler
    .long PWMO_CMP1_IRQ_IRQHandler
    .long PWMO_CMP2_IRQ_IRQHandler
    .long PWMO_CMP3_IRQ_IRQHandler
    .long PWM1_CMP0_IRQ_IRQHandler
    .long PWM1_CMP1_IRQ_IRQHandler
    .long PWM1_CMP2_IRQ_IRQHandler
    .long PWM1_CMP3_IRQ_IRQHandler
    .long PWM2_CMP0_IRQ_IRQHandler
    .long PWM2_CMP1_IRQ_IRQHandler
    .long PWM2_CMP2_IRQ_IRQHandler
    .long PWM2_CMP3_IRQ_IRQHandler

    // Define default implementations for interrupts, redirecting to
    // Default_Handler when not implemented.
    IRQ NMI_Handler
    IRQ HardFault_Handler
    IRQ MemoryManagement_Handler
    IRQ BusFault_Handler
    IRQ UsageFault_Handler
    IRQ SVC_Handler
    IRQ DebugMon_Handler
    IRQ PendSV_Handler
    IRQ SysTick_Handler
    IRQ Watchdog_IRQ_IRQHandler
    IRQ RTC_IRQ_IRQHandler
    IRQ UART0_IRQ_IRQHandler
    IRQ UART1_IRQ_IRQHandler
    IRQ QSPI0_IRQ_IRQHandler
    IRQ QSPI1_IRQ_IRQHandler
    IRQ QSPI2_IRQ_IRQHandler
    IRQ GPIO_0_IRQ_IRQHandler
    IRQ GPIO_1_IRQ_IRQHandler
    IRQ GPIO_2_IRQ_IRQHandler
    IRQ GPIO_3_IRQ_IRQHandler
    IRQ GPIO_4_IRQ_IRQHandler
    IRQ GPIO_5_IRQ_IRQHandler
    IRQ GPIO_6_IRQ_IRQHandler
    IRQ GPIO_7_IRQ_IRQHandler
    IRQ GPIO_8_IRQ_IRQHandler
    IRQ GPIO_9_IRQ_IRQHandler
    IRQ GPIO_10_IRQ_IRQHandler
    IRQ GPIO_11_IRQ_IRQHandler
    IRQ GPIO_12_IRQ_IRQHandler
    IRQ GPIO_13_IRQ_IRQHandler
    IRQ GPIO_14_IRQ_IRQHandler
    IRQ GPIO_15_IRQ_IRQHandler
    IRQ GPIO_16_IRQ_IRQHandler
    IRQ GPIO_17_IRQ_IRQHandler
    IRQ GPIO_18_IRQ_IRQHandler
    IRQ GPIO_19_IRQ_IRQHandler
    IRQ GPIO_20_IRQ_IRQHandler
    IRQ GPIO_21_IRQ_IRQHandler
    IRQ GPIO_22_IRQ_IRQHandler
    IRQ GPIO_23_IRQ_IRQHandler
    IRQ GPIO_24_IRQ_IRQHandler
    IRQ GPIO_25_IRQ_IRQHandler
    IRQ GPIO_26_IRQ_IRQHandler
    IRQ GPIO_27_IRQ_IRQHandler
    IRQ GPIO_28_IRQ_IRQHandler
    IRQ GPIO_29_IRQ_IRQHandler
    IRQ GPIO_30_IRQ_IRQHandler
    IRQ GPIO_31_IRQ_IRQHandler
    IRQ PWMO_CMP0_IRQ_IRQHandler
    IRQ PWMO_CMP1_IRQ_IRQHandler
    IRQ PWMO_CMP2_IRQ_IRQHandler
    IRQ PWMO_CMP3_IRQ_IRQHandler
    IRQ PWM1_CMP0_IRQ_IRQHandler
    IRQ PWM1_CMP1_IRQ_IRQHandler
    IRQ PWM1_CMP2_IRQ_IRQHandler
    IRQ PWM1_CMP3_IRQ_IRQHandler
    IRQ PWM2_CMP0_IRQ_IRQHandler
    IRQ PWM2_CMP1_IRQ_IRQHandler
    IRQ PWM2_CMP2_IRQ_IRQHandler
    IRQ PWM2_CMP3_IRQ_IRQHandler
